# Do we want a DEBUG build
%define dbg_opt %{?dbg}%{!?dbg:0}
# Use the Vstr debug libraries?
%define dbg_vstr_opt %{?dbg_vstr}%{!?dbg_vstr:0}
# Use the Timer_q debug libraries?
%define dbg_timer_q_opt %{?dbg_timer_q}%{!?dbg_timer_q:0}

%if %{dbg_opt}
%define dbg_arg_main --enable-debug
%else
%define dbg_arg_main %nil
%endif

%if %{dbg_vstr_opt}
%define dbg_arg_vstr --enable-debug-vstr
%else
%define dbg_arg_vstr %nil
%endif

%if %{dbg_timer_q_opt}
%define dbg_arg_timer_q --enable-debug-timer_q
%else
%define dbg_arg_timer_q %nil
%endif

%define makeopts %{?jnum:-j %jnum}%{!?jnum:%nil}

%define statedir /var

%define and_httpd_uid 444
%define wwwdir %{statedir}/www


Summary: Secure, simple and fast HTTP server
Name: and-httpd
Version: 0.99.11
Release: 1
License: LGPL
Group: System Environment/Daemons
URL: http://www.and.org/and-httpd
Source0: %{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: vstr >= 1.0.14
BuildRequires: pkgconfig >= 0.8
BuildRequires: vstr-devel, timer_q-devel, socket_poll-devel, libcap-devel
BuildRequires: perl
Provides: webserver

%description

And-httpd is currently only a URL to file mapping daemon,
in other words in can take an incoming URL and map it
to a file in a number of ways. However it cannot do CGI
or anything like apache-httpd mod_python etc. ... it cannot
even dynamically create directory listings, however the -tools
package contains utilities that can do them outside of the
daemon.

%package tools
Summary: Tools to help with managing webserver data
Group: Development/Tools
Requires: scons, python, perl, perl-File-Slurp

%description tools
Tools to help managing data under /var/www, including:

. automatic directory indexer.
. automatic gzip encoding generator.
. automatic converter from and-httpd syslog to Apache-httpd combined log.
. automatic status page generator.
. HTML -> text converter.

%prep
%setup -q

%build

./configure %{dbg_arg_main} %{dbg_arg_vstr} %{dbg_arg_timer_q} \
  --prefix=%{_prefix} --mandir=%{_mandir} --localstatedir=%{statedir} \
  --datadir=%{_datadir} --sysconfdir=%{_sysconfdir} --libdir=%{_libdir}

make %{makeopts}

%check

make %{makeopts} check

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

# These are "sometimes" created by magic...
touch $RPM_BUILD_ROOT/%{wwwdir}/scons_and_httpd_helpers.pyc
touch $RPM_BUILD_ROOT/%{wwwdir}/scons_and_httpd_helpers.pyo

%clean
rm -rf $RPM_BUILD_ROOT

%pre

# Add the user id's on install
if [ $1 = 1 ]; then
/usr/sbin/useradd -c "And-httpd" -u %{and_httpd_uid} \
        -s /sbin/nologin -r -d %{wwwdir} and-httpd 2> /dev/null || :
fi

%post

if [ $1 = 1 ]; then
    /sbin/chkconfig --add and-httpd
fi
if [ $1 = 2 ]; then
    /sbin/service and-httpd condrestart > /dev/null 2>&1
fi

%preun

if [ $1 = 0 ]; then
    /sbin/service and-httpd stop > /dev/null 2>&1
    /sbin/chkconfig --del and-httpd
fi

%files
%defattr(-,root,root,-)
%{_sbindir}/
%{_bindir}/
%{_sysconfdir}/and-httpd/conf.d/README
%{_sysconfdir}/init.d/and-httpd
%{_sysconfdir}/cron.hourly/and-httpd_*
%config(noreplace) %{_sysconfdir}/and-httpd/and-httpd.conf
%config(noreplace) %{_sysconfdir}/and-httpd/conf.d/_*.conf
%config %{_sysconfdir}/and-httpd/mime_types_extra.txt
%config(noreplace) %{wwwdir}/err/*
%config(noreplace) %{wwwdir}/conf/*
%{wwwdir}/conf_tmpl/*
%config(noreplace) %{wwwdir}/html/*
%{wwwdir}/generated_html
%doc
%{_datadir}/doc/and-httpd-0.99.11
%{_mandir}/man8/and-httpd*
%{_mandir}/man5/and-httpd*

%files tools
%defattr(-,root,root,-)
%{_datadir}/and-httpd-0.99.11-tools/*
%{_libexecdir}/and-httpd-0.99.11-tools/*
%config(noreplace) %{wwwdir}/scons_and_httpd_helpers.py
%{wwwdir}/scons_and_httpd_helpers.pyc
%ghost %{wwwdir}/scons_and_httpd_helpers.pyo
%config %{wwwdir}/SConstruct-tmpl


%changelog
* Sat Sep  9 2006 James Antill <james@and.org> - 0.99.11-1
- Move make check to FC check section
- Tweak compiled python files.

* Fri Jun  2 2006 James Antill <james@and.org> - and-httpd-0.99.8-2
- Remove built python files for FC5.

* Fri Jun  2 2006 James Antill <james@and.org> - and-httpd-0.99.8
- Copy scons helper, and add conf+html files.

* Wed Nov 30 2005 James Antill <james@and.org> - and-httpd-0.99.6
- Only try adding the user on install

* Sat Sep 10 2005 James Antill <james@and.org> - and-httpd-0.99-1
- Initial build.

